"""This module manages sending and saving mails. Most of the code is adopted
from Jakob's implementation of a digital Kurswahl for the GT. Thank you for the
help!"""

import ssl
from email import charset
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.utils import formatdate

from smtplib import SMTP
from typing import Optional

_connection: Optional[SMTP] = None
# Encode utf-8 strings using utf-8, and not base-64
# See https://bugs.python.org/issue12552
charset.add_charset('utf-8', charset.SHORTEST)

def open_connection():
    global _connection
    _connection = SMTP("mail.urz.uni-heidelberg.de", 587)
    _connection.starttls(context=ssl.create_default_context())

def send_mail(msg: MIMEMultipart, auto_close_connection: bool = True):
    if _connection is None:
        open_connection()
    try:
        print(f"Sending to {msg['To']}...")
        _connection.send_message(msg)
    finally:
        if auto_close_connection:
            close_connection()

def save_mail(file, msg):
    with open(file, "wb") as f:
        f.write(msg.as_bytes())

def generate_mail(recipient, content):
    msg = MIMEMultipart()
    msg["From"] = "knecht-robobert@cl.uni-heidelberg.de"
    msg["To"] = recipient
    msg["Date"] = formatdate(localtime=True)
    msg["Subject"] = "Wunderbares Winterwichteln"
    msg["Bcc"] = "knecht-robobert@cl.uni-heidelberg.de"
    text = MIMEText(content)
    msg.attach(text)
    return msg

def close_connection():
    global _connection
    _connection.quit()

